/*
 * @(#)ConformanceTesting.java         12/01/31
 *
 * Copyright (c) .
  * All rights reserved.
 *
 * This software is the confidential and proprietary information of ReDCAD 
 * Reasearch Unit, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with ReDCAD.
 */
package Tester;

import Tester.FrameTest;


import java.io.IOException;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


/**
 * Class description goes here.
 *
 * @version 	0.1 31 Jan 2012
 * @author 	Afef JMAL, Manel HAMZA
 */
public class ConformanceTesting {
    // Timed Automata TA 
    public static String TA;
    //.bpel Path file
    public static String BPELPath;
    //the name of the deployed BPEL process
    public static String BPELName;
    // Number of test Execution 
    public static int N;
    // Network time out
    public static int tmax;
    //Initial State
    public static State s0;
    //type of BPELInput
    public static String typeBPELInput;
    //BPEL input
    public static Object inputBPEL;
    // the endPoint of the invoked partner service
     public static String invokedPartnerServiceEndPoint ;
    //the name of the current invoked partner service
        public static String invokedPartnerServiceName;
    //the response generated to the current invoked partner service 
    public static String outputGeneration;


    public static void main(String[] args) throws IOException, Exception {
    
        //L'tat courant 
         State currentState;
        //la transition courante
        Transition currentTransition;
        // La liste qui contient tous les cas de test gnrs
        List<String> tcList = new ArrayList<String>();
        // La liste des transitions qui suivent l'tat courant
        List<Transition> acList = new ArrayList<Transition>();
        // la liste des locations de la spcification
        List<State> locationList = new ArrayList<State>();
        // la liste des locations qui sont suivies par un nombre de transition >=2
        List<State> locationAvec2Transitions = new ArrayList<State>();
        // extraction des  transitions de type Input, GuardInput, ou Timed transition  partir de acList
        List<Transition> itList = new ArrayList<Transition>();
        // extraction des  transitions de type Input, GuardInput, ou Timed transition  partir de acList
        List<Transition>  gVarList = new ArrayList<Transition>();
        //list des chemin parcourus
        List<String> pathsList = new ArrayList<String>();
        //List of covered actions in a choosen path
        List<String> tc = new ArrayList<String>();
        //the Index of the path choosen from the the pathsList
        int pathIndex =0;
        // a counter of a synchronised State
        int syncStateCounter =0;
        //a counter of transition to cross in path choosen 
        int TransitionIndex =0;
        //the verdict of the test case
        String verdict = null;
        
        
       /********************************************************************************
       * Extract Inputs 
       * 1- Timed Automata TA, 
       * 2- BPEL Implementation Path, 
       * 3- Number of test Execution
       * 4- Network time out
       *******************************************************************************/
       //Frame FrameTest1 = new FrameTest1();
       //launch the GUI application
        Frame frame = new Frame ();
        TreatmentFrame ft = new TreatmentFrame(frame);
        /** 1- Timed Automata TA **/
        TA =ft.getSpecPath();
        /** 2- BPEL Implementation **/
        //.bpel Path file
        BPELPath = ft.getBPELPath();
        // extract information from .bpel , .xsd , .wsdl files of the BPEL
        TreatmentBPELFiles TreatBPELFiles = new TreatmentBPELFiles(BPELPath);
        //the name of the deployed BPEL process
        BPELName = TreatBPELFiles.getBPELName();
        /** 3- Number of test Execution **/
        N = ft.getRepetitionNumber();
        /** 4- Network time out **/
        tmax =ft.getTmax();
        
         /***********************************************************************
          * 
          * Initializations :
          * Execution counter, current State, List of actions
          *************************************************************************/
             
              /**
               * instanciate classes of traitement spec, BPEL files,  
               */
              
            TreatmentSpec tSpec = new TreatmentSpec(TA);
            TreatmentBPELFiles tBpelFiles= new TreatmentBPELFiles(tSpec.getBPELwsdlPath(),tSpec.getBPELxsdPath(),BPELPath); 
            TreatmentVariable tVar = new TreatmentVariable();
            TreatmentItList tItList = new TreatmentItList();
            TreatmentTransition tt = new TreatmentTransition();
            
            // get the initial State of Timed Automata
            s0 = tSpec.getInitialState();
        // current State in the test excution
        currentState = s0;
        // the counter of the test execution 
        int executionCounter = 0;
        //the name of implementation under test
         BPELName = tBpelFiles.getBPELName();
          //the type of the input of the implementation under test
         typeBPELInput = tBpelFiles.getType(tBpelFiles.getInputName());
        // the result of one action
        String result ;
         System.out.println("type ="+typeBPELInput);
        
        System.out.println("BPELName : "+BPELName);
       
         /*********************************************************************
          * Output : a test report
          *
         *********************************************************************/
        TestReport Report = new TestReport(BPELName);
        Report.setTestExecutionNumber(1);
        
        
         /********************************************************************
          *                          
          *                          Execution :
          *
         ********************************************************************/
                
         /**
          * Extract Information from the inputs
          **/
        //get the list of paths possibles of the TA
        pathsList = tSpec.getPathsList();
        //the number of Paths
        int pathsNumber = pathsList.size();
        
        /**
         * Start the test Execution
         * repeat the test N times
         */
    
        while (executionCounter < N) {
           

            //A chaque itration on supprime le contenu de acList et itList pour qu'elles contiennent les transitions de la 
            //la nouvelle state
            acList.clear();
            itList.clear();
            gVarList.clear();
            acList = tSpec.getNextTransition(currentState);
            if (!acList.isEmpty()) {
                //extraire Les Input , GuardInput, Timed , Free , Assignement Transitions et les mettre dans ItList
                //extraire Les GuardVar Transitions et les mettre dans gVarList

                Iterator iAcList = acList.iterator();
                while (iAcList.hasNext()) {
                    Transition acListCourantTransition = (Transition)iAcList.next();
                    System.out.println(acListCourantTransition.source.id +"->" +  acListCourantTransition.target.id);
                    String type = tSpec.getTypeTransition(acListCourantTransition);
                    System.out.println("type of current transition = " + type);
                    if (tItList.isAnItListItem(tSpec.getTypeTransition(acListCourantTransition))) {
                        itList.add(acListCourantTransition);
                    }
                    if (type.equals("GuardVar")){
                        gVarList.add(acListCourantTransition);
                    }
                }
                if (!itList.isEmpty()) {
                    if (itList.size() > 1) {
                        //si itList contient plusieurs transitions, on doit choisir  chaque fois une transition en essyant de ne pas avoir 
                        // rpter les chemins dja pass.
                        char a;
                        a = pathsList.get(pathIndex).charAt(syncStateCounter);
                        TransitionIndex = Integer.parseInt("" + a);
                        System.out.println("indice=" + TransitionIndex);
                        //pass to the next synchronysed state
                        syncStateCounter++;
                        
                    } else if (itList.size() == 1) {
                        TransitionIndex = 0;
                    }
                    currentTransition = itList.get(TransitionIndex);
                    //extraire le type de la transition choisie pour dfinir sa mchode de traitement
                    String typeItListTransition = 
                    tSpec.getTypeTransition(currentTransition);
                    System.out.println(typeItListTransition);
                    //traiter la transition selon son type
                     result =       tt.treatTransition(typeItListTransition, currentTransition.source, currentTransition.target);
                    //ajouter le l'opration faite au test case
                    tc.add(result);
                    currentState = currentTransition.target;

                }
                 /**treatment of guardVar Transition */
                else if (!gVarList.isEmpty()){
                    System.out.println("!gVarList.isEmpty()");
                    System.out.println(gVarList.get(0).source.id+"-->"+gVarList.get(0).target.id);
                    System.out.println(gVarList.get(1).source.id+"-->"+gVarList.get(1).target.id);
                    if ((tSpec.generateActionOfGuardVarTransition(gVarList.get(0).source,gVarList.get(0).target)).contains("output==")){
                        String trueActionOfGuardVar ;
                        trueActionOfGuardVar=(tSpec.generateActionOfGuardVarTransition(gVarList.get(0).source, gVarList.get(0).target));
                        String [] tab;
                        tab =trueActionOfGuardVar.split("==");
                        System.out.println("Tab[1]="+tab[1]);
                            System.out.println("outputGeneration = "+outputGeneration);
                        if (outputGeneration.equals(tab[1])){
                            currentState = gVarList.get(0).target;
                            System.out.println("currentState.id "+currentState.id);
                        }
                        else currentState = gVarList.get(1).target;
                     
                        }
                        else {
                            if ((tSpec.generateActionOfGuardVarTransition(gVarList.get(1).source,gVarList.get(0).target)).contains("output==")){
                                String trueActionOfGuardVar ;
                                trueActionOfGuardVar=(tSpec.generateActionOfGuardVarTransition(gVarList.get(0).source, gVarList.get(1).target));
                                String [] tab;
                                tab =trueActionOfGuardVar.split("==");
                                System.out.println("Tab[1]="+tab[1]);
                                    System.out.println("outputGeneration = "+outputGeneration);
                                if (outputGeneration.equals(tab[1])){
                                    currentState = gVarList.get(1).target;
                                    System.out.println("currentState.id "+currentState.id);
                                }
                                    else currentState = gVarList.get(0).target;
                                }
                            
                        }

                    Iterator igVarList = gVarList.iterator();
                    while (igVarList.hasNext()) {
                        Transition gVarListCourantTransition = (Transition)igVarList.next();
                        System.out.println(tSpec.generateActionOfGuardVarTransition(gVarListCourantTransition.source, gVarListCourantTransition.target));
                        String trueActionOfGuardVar ;
                        if ((tSpec.generateActionOfGuardVarTransition(gVarListCourantTransition.source, gVarListCourantTransition.target)).contains("output==")){
                        trueActionOfGuardVar=(tSpec.generateActionOfGuardVarTransition(gVarListCourantTransition.source, gVarListCourantTransition.target));
                        String [] tab;
                        tab =trueActionOfGuardVar.split("==");
                        System.out.println("Tab[1]="+tab[1]);
                            System.out.println("outputGeneration = "+outputGeneration);
                        if (outputGeneration.equals(tab[1])){
                            currentState = gVarListCourantTransition.target;
                            System.out.println("currentState.id "+currentState.id);
                        }
                        }
                        
                    }
              
                }
                /**treatment of  output and outputAssignementClock Transition */
                else {
                    //treatment of the final Transition
                    if ((acList.size() == 1) && 
                        (acList.get(0).target.id).equals(s0.id)) {
                        System.out.println("Traitement de la transition fianle");
                        //TODO intercept the final Response to check the type of the final response
                        //just now suppose when we arrive to the final response verdict = Pass;
                        verdict = "Verdict = PASS";
                        //add verdict to the List tc
                        tc.add(verdict);
                        //initialize currentState to s0 to start a new test 
                        currentState = s0;
                        //increment the executionCounter to start new test
                        executionCounter++;
                        //initialize tc to save the actions of the next transitions 
                        //tc.clear(); TODO check the correct place of tc.clear 
                        //new path for test is chosen from pathList
                        //if the executionCounter is bigger than the paths number, the choice of the path to cross will be randomly 
                        // else we will choose a path (nb executionCounter) from the pathsList 
                        if (executionCounter > (pathsNumber - 1)) {
                            pathIndex = (int)(Math.random() * (pathsNumber));
                            System.out.println("pathIndex = " + pathIndex);
                        } else {
                            //increment the pathIndex to choose the next path from the pathList
                            pathIndex++;
                            System.out.println("pathIndex = " + pathIndex);

                            syncStateCounter = 0;
                        }

                    } // the end of treatment of final transition
                     else{
                     //treatment of output intermediate transition
                    OutputTransition ot =new OutputTransition();
                     long  waitingTime = 0;
                    long timeToStart = System.currentTimeMillis();
                   //waint until an invoked partner service has sent an input to the tester 
                    System.out.println("ot. ReceptionInput = "+ot.getReceptionInput());
                    while (ot.getInput().equals("-1") && waitingTime<tmax){
                        // wait
                        waitingTime =System.currentTimeMillis()-timeToStart ;
                       
                    }
                    System.out.println("waitingTime = "+waitingTime);
                    //the case that waitingTime > tmax
                    if (waitingTime>tmax){
                        verdict = "Verdict = Fail: Reaching network timeout";
                        System.out.println(verdict);
                        tc.add(verdict);
                        System.exit(0);
                    }
                    else{
                    //get the endPoint of the invoked partner service
                    invokedPartnerServiceEndPoint =ot.getPSEndPoint();
                    while (ot.getPSEndPoint().equals("-1")){
                        System.out.println("ot.getPSEndPoint=-1");
                    }
                    invokedPartnerServiceEndPoint =ot.getPSEndPoint();

                    //initialize PsEndPoint and input in testerQueue  for the next use
                   
                   ot.initializePSEndPoint();
                    
                     System.out.println("ot.getPSEndPoint()= "+invokedPartnerServiceEndPoint);
                    // from the partner service 's endPoint,  get the name of the service
                    // First, get list descritions of the diiferent partners in the specification 
                    //description has the form (Name of partner service, path of the wsdl of the partner service , endPoint of the partner service)
                    //Second, get the description of the partner service wich its endPoint = InvokedPartnerServiceEndPoint
                    List partnersDescription =tSpec.getPartnersDescription();
                    Iterator i = partnersDescription.iterator();
                    //the description of the invoked partner service
                    String invokedPartnerDescription = null;
                    while (i.hasNext()) {
                        String currentDescription = (String)i.next();
                        System.out.println("cuurent description = "+currentDescription);
                        //check if the invokedPartnerService exists in the specification
                        if (currentDescription.contains(invokedPartnerServiceEndPoint)){
                        invokedPartnerDescription = currentDescription;
                        }
                    }
                        //from its description, get the name of the invoked partner service
                        invokedPartnerServiceName =tSpec.getPartnerServiceName(invokedPartnerDescription);
                        System.out.println("from specification invokedWebService="+invokedPartnerServiceName);
                        //check, in the specification, if the invocation of the service partner can be done from the current state
                        currentTransition =tSpec.search("invokedWebService="+invokedPartnerServiceName,currentState);
                        //if there is a transition in the specification that invokes the actual partner service from the current state
                        if (currentTransition != null) {
                        System.out.println(currentTransition.source.id + " --invoke_"+invokedPartnerServiceName+"--> "+currentTransition.target.id);
                        /** get the input received by the partner service and check if its type conforms to the specification
                        * first, we will get the partner service's input type from its specification 
                        * second, get the input received by the partner service
                        * finaly, check if this input conforms to the type described in the specification 
                        */
                        //get the path of the wsdl of the invoked partner service
                        String invokedPartnerServiceWSDLPath = tSpec.getPartnerServicePath(invokedPartnerDescription);
                        System.out.println("invokedPartnerServiceWSDLPath = "+invokedPartnerServiceWSDLPath);
                        //connect to the wsdl of the invoked partner service
                        TreatmentWsdlOraclePartnerService twPS = new TreatmentWsdlOraclePartnerService(invokedPartnerServiceWSDLPath);
                        //from the wsdl of the partner service, get the type of the input 
                        String typeInput = twPS.getType(twPS.getInputName());
                        System.out.println("type input = " + typeInput);
                        //get the input sent by the BPEL to the partner service
                         String inputSentByBPEL = ot.getInput();
                         // initialize the input for the next uses
                         ot.initializeinput();
                         //check the conformance between the the type of the input sent sent by the BPEL to partner service 
                         // and the type required by the specification 
                          System.out.println("inputSentBythe BPEL = "+inputSentByBPEL);
                         System.out.println("ot.getInput() after initializing= "+ot.getInput());
                         boolean checkInput = tVar.checkType(inputSentByBPEL, typeInput);
                         //if the input sent by the BPEL to the partner service conforms to the specifcation (wsdl of the partner service),
                         //generate an output that conforms to specification and send it to partner service 
                         if (checkInput){
                             //from the wsdl of the partner service, get the type of the input 
                             String typeOutput = twPS.getType(twPS.getOutpuName());
                             System.out.println("type output = " + typeOutput);
                             //generate an output to the Partner service in accoredance with type output
                             outputGeneration = tVar.DataGeneration(typeOutput,5);
                            System.out.println("generated output = " + 
                                               outputGeneration);
                        } else {
                            //post verdict
                            verdict = "Verdict = FAIL : Type Incompatibility";
                            System.out.println(verdict);
                            tc.add(verdict);
                        }
     
                       String  outputResult = "(!invoke_"+invokedPartnerServiceName+"("+inputSentByBPEL+"),"+((float)(waitingTime/1000)+")") ;
                       tc.add(outputResult);
                    } else {
                        System.out.println("(t=null)");
                        verdict = "Verdict = FAIL: Incorrect invoked partner service";
                        System.out.println(verdict);
                        tc.add(verdict);
                    }
                 System.out.println("ot. ReceptionInput = "+ot.getReceptionInput());
                    currentState = currentTransition.target;
                    } //end of the case : not reaching network time out 
                }//end of treatement of output intermediate transition
                }//end of treatement of output transition
                 System.out.println("les lments de tcList sont : ");
                Iterator i = tc.iterator();
                while (i.hasNext()) {
                    String  current =(String) i.next();
                    System.out.println(current);
                }
             }
      } 
             System.exit(0);
    }
}
