package Tester;

import java.io.File;

import java.util.Iterator;
import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

public class TreatmentBPELFiles {
    public String BPELwsdlPath;
    public String BPELxsdPath;
    public String BPELbpelPath;
    public Document document;
    public Element racineWSDL;
    public Element racineBPEL;
    public Element racineXSD;
    public String inputName;
    public String outputName;
    public String type;

    public TreatmentBPELFiles(String BPELwsdlPath,String BPELxsdPath,String BPELbpelPath) {
         this.BPELwsdlPath=BPELwsdlPath;
         this.BPELxsdPath= BPELxsdPath;
         this.wsdlConnection();
         this.xsdConnection();
        this.BPELbpelPath=BPELbpelPath;
        this.bpelConnection();
    }
    public TreatmentBPELFiles(String BPELbpelPath) {
         this.BPELbpelPath=BPELbpelPath;
         this.bpelConnection();
        }
    /**
     * used to access the wsdl file of the BPEL
     */
    public void wsdlConnection(){
        //On cre une instance de SAXBuilder
        SAXBuilder sxb = new SAXBuilder();
              try {
            //On cre un nouveau document JDOM avec en argument le fichier XML
            //Le parsing est termin ;)
            // le fichier de spcification est celui donne pass dans le champ texte spcification de l'interface graphique fr
            document = sxb.build(new File(BPELwsdlPath));
            } catch (Exception e) {
            System.out.println(e);
        }

        //On initialise un nouvel lment racine avec l'lment racine du document.
        racineWSDL = document.getRootElement();
    }
   
   
    /**
     * used to access the xsd file of the BPEL
     */
    public void xsdConnection(){
        //On cre une instance de SAXBuilder
        SAXBuilder sxb = new SAXBuilder();
              try {
            //On cre un nouveau document JDOM avec en argument le fichier XML
            //Le parsing est termin ;)
            // le fichier de spcification est celui donne pass dans le champ texte spcification de l'interface graphique fr
            document = sxb.build(new File(BPELxsdPath));
            } catch (Exception e) {
            System.out.println(e);
        }
        //On initialise un nouvel lment racine avec l'lment racine du document.
        racineXSD = document.getRootElement();
    }
    
    /**
     * used to access the bpel file of the BPEL
     */
    public void bpelConnection(){
        //On cre une instance de SAXBuilder
        SAXBuilder sxb = new SAXBuilder();
              try {
            //On cre un nouveau document JDOM avec en argument le fichier XML
            //Le parsing est termin ;)
            // le fichier de spcification est celui donne pass dans le champ texte spcification de l'interface graphique fr
            document = sxb.build(new File(BPELbpelPath));
            } catch (Exception e) {
            System.out.println(e);
        }

        //On initialise un nouvel lment racine avec l'lment racine du document.
        racineBPEL = document.getRootElement();
    }
    
    /**
     * used to get the name of the BPEL 
     * this name is described in the .bpel file
     **/
     public String getBPELName(){
         return racineBPEL.getAttributeValue("name");
     }
     
    /**
     * used to get the name of the BPEL input variable described in this wsdl
     * This item includes all input parameters  
     **/
    public String getInputName() {
        List children = racineWSDL.getChildren();
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
             if (current.getName().equals("message")) {
                if (current.getAttributeValue("name").contains("RequestMessage")) {
                    List portTypeChildren = current.getChildren();
                    Iterator iportTypeChildren = portTypeChildren.iterator();
                    while (iportTypeChildren.hasNext()) {
                        //parcourir les balises template
                        Element currentOperation = 
                            (Element)iportTypeChildren.next();
                        if (currentOperation.getName().equals("part")) {

                            //parcourir les balises template
                            String currentInput = 
                                (String)currentOperation.getAttributeValue("element");
                            String[] information;
                            information = currentInput.split(":");
                            inputName = information[1];
                        }
                    }
                }
            }
        }
      return   inputName;
    }
    
   
    /**
     * used to get the name of the BPEL Output variable described in this wsdl
     * 
     **/
     public String getOutputName() {
     List children = racineWSDL.getChildren();
     Iterator ichildren = children.iterator();
     while (ichildren.hasNext()) {
         //parcourir les balises template
         Element current = (Element)ichildren.next();
          if (current.getName().equals("message")) {
             if (current.getAttributeValue("name").contains("ResponseMessage")) {
                 List portTypeChildren = current.getChildren();
                 Iterator iportTypeChildren = portTypeChildren.iterator();
                 while (iportTypeChildren.hasNext()) {
                     //parcourir les balises template
                     Element currentOperation = 
                         (Element)iportTypeChildren.next();
                     if (currentOperation.getName().equals("part")) {

                         //parcourir les balises template
                         String currentInput = 
                             (String)currentOperation.getAttributeValue("element");
                         String[] information;
                         information = currentInput.split(":");
                         outputName = information[1];
                     }
                 }
             }
         }
     }
     return   outputName;
     }
   
    
    /**
     * used to get the type of the BPEL input/output variable
     * this type is described in the xsd file
     * the input parameter of this method is the name of the input varible of
     * the BPEL composition described in the wsdl file
     **/
    public String getType(String name) {

        List children = racineXSD.getChildren();
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            if (current.getAttributeValue("name").equals(name)){
                List elementChildren = current.getChildren();
                Iterator ielementChildren = elementChildren.iterator();
                while (ielementChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentComplexType = (Element)ielementChildren.next();
                List complexTypeChildren = currentComplexType.getChildren();
                Iterator iComplexTypeChildren = complexTypeChildren.iterator();
                while (iComplexTypeChildren.hasNext()) {
                    Element currentSequence = (Element)iComplexTypeChildren.next();
                    List sequenceChildren = currentSequence.getChildren();
                    Iterator iSequenceChildren = sequenceChildren.iterator();
                    while (iSequenceChildren.hasNext()) {
                        Element currentElement = (Element)iSequenceChildren.next();
                        type =currentElement.getAttributeValue("type");
                    }
                    
                }
            }
            }
           
        }
        return type;
    }
}

