package Tester;

import java.io.File;

import java.util.ArrayList;
import java.util.Iterator;

import java.util.List;

import org.jdom.input.SAXBuilder;
import org.jdom.Element;
import org.jdom.Document;
public class TreatmentWsdlAxisPartnerService {
    public Document document;
    public Element racine;
    public String wsdlPath;
    public String endPoint;
    public String nameInput;
    public String partName;
    public String outputName;
    public List<String> parametersType = new ArrayList<String>();
    public TreatmentWsdlAxisPartnerService(String wsdlPath) {
        this.wsdlPath=wsdlPath;
        //On cre une instance de SAXBuilder
        SAXBuilder sxb = new SAXBuilder();
              try {
            //On cre un nouveau document JDOM avec en argument le fichier XML
            //Le parsing est termin ;)
            // le fichier de spcification est celui donne pass dans le champ texte spcification de l'interface graphique fr
            document = sxb.build(new File(wsdlPath));
            } catch (Exception e) {
            System.out.println(e);
        }

        //On initialise un nouvel lment racine avec l'lment racine du document.
        racine = document.getRootElement();
    
    }
    /**
     * used to access the wsdl file of the partner service 
     * generated by Axis
     */
    public void wsdlConnection(){
        //On cre une instance de SAXBuilder
        SAXBuilder sxb = new SAXBuilder();
              try {
            //On cre un nouveau document JDOM avec en argument le fichier XML
            //Le parsing est termin ;)
            // le fichier de spcification est celui donne pass dans le champ texte spcification de l'interface graphique fr
            document = sxb.build(new File(wsdlPath));
            } catch (Exception e) {
            System.out.println(e);
        }

        //On initialise un nouvel lment racine avec l'lment racine du document.
        racine = document.getRootElement();
    }
    
    
    /**
     * used to get the endpoint of the web service described by this wsdl
     * 
     **/
    public String  getEndPoint() {
       List children = racine.getChildren();
       
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            if (current.getName().equals("service")){
                List serviceChildren = current.getChildren(); 
                Iterator iServiceChildren = serviceChildren.iterator();
                while (iServiceChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentPort = (Element)iServiceChildren.next();
                    if (currentPort.getName().equals("port")){
                        List portChildren = currentPort.getChildren();
                        Iterator iPortChildren = portChildren.iterator();
                        while (iPortChildren.hasNext()) {
                            //parcourir les balises template
                            Element currentAddress = (Element)iPortChildren.next();
                            if (currentAddress.getName().equals("address")){
                                endPoint = currentAddress.getAttributeValue("location");
                            }
                        }
                    }
                }
            }
        }
        
        return endPoint;
      
    }
    /**
     * used to get the name of the web service input variable described in this wsdl
     * This item includes all input parameters  
     **/
    public String  getInputName() {
       List children = racine.getChildren();
       
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            System.out.println(current);
            if (current.getName().equals("portType")){
                List portTypeChildren = current.getChildren(); 
                Iterator iportTypeChildren = portTypeChildren.iterator();
                while (iportTypeChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentOperation = (Element)iportTypeChildren.next();
                    if (currentOperation.getName().equals("operation")){
                        List inputChildren = currentOperation.getChildren();
                        Iterator iinputChildren = inputChildren.iterator();
                        while (iinputChildren.hasNext()) {
                            //parcourir les balises template
                            Element currentInput = (Element)iinputChildren.next();
                            if (currentInput.getName().equals("input")){
                                nameInput = currentInput.getAttributeValue("name");
                            }
                        }
                    }
                }
            }
        }
        return nameInput;
      
    }
    
    /**
     * used to get the Part Name of the web service input variable described in this wsdl
     * usually the part have an attribute element = "impl:PartName"
     * this method retrieves the PartName
     **/
    public String getPartName(String name) {
        List children = racine.getChildren();
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            System.out.println(current);
            if (current.getName().equals("message") && 
                (current.getAttributeValue("name").equals(name))) {
                System.out.println("Yesss message,name");
                List messageChildren = current.getChildren();
                Iterator imessageChildren = messageChildren.iterator();
                while (imessageChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentPart = (Element)imessageChildren.next();
                    if (currentPart.getName().equals("part")) {
                        String nameElement = 
                        currentPart.getAttributeValue("element");
                        String[] elementList;
                        elementList = nameElement.split(":");
                        partName = elementList[1];
                        System.out.println(partName);
                    }
                }
            }
        }
        return partName;
    }

    /**
     * used to get the (inpu/output) type  of the web service described in this wsdl
     * types can be boolean, short, float, int 
     * this method return the list of types the input parameters ordered like they are ordered in the method
     * example method(String a , int b , float c) the list of types will be (String, int , float)
     * 
     **/
    public List getTypes(String PartName) {
        parametersType.clear();
        List children = racine.getChildren();
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            System.out.println(current);
            if (current.getName().equals("types")) {
                System.out.println("Yesss message,types");
                List typesChildren = current.getChildren();
                Iterator itypesChildren = typesChildren.iterator();
                while (itypesChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentSchema = (Element)itypesChildren.next();
                    System.out.println(currentSchema);
                    if (currentSchema.getName().equals("schema")) {

                        System.out.println("OK schema");
                        List schemaChildren = currentSchema.getChildren();
                        Iterator ischemaChildren = schemaChildren.iterator();
                        while (ischemaChildren.hasNext()) {
                            //parcourir les balises template
                            Element currentPartElement = 
                                (Element)ischemaChildren.next();

                            if (currentPartElement.getAttributeValue("name").equals(PartName)) {
                                System.out.println("yesss partName is found ");

                                List PartElementChildren = 
                                    currentPartElement.getChildren();
                                Iterator iPartElementChildren = 
                                    PartElementChildren.iterator();
                                while (iPartElementChildren.hasNext()) {
                                    //parcourir les balises template
                                    Element currentComplexType = 
                                        (Element)iPartElementChildren.next();
                                    System.out.println(currentComplexType);
                                    List ComplexTypeChildren = 
                                        currentComplexType.getChildren();
                                    Iterator iComplexTypeChildren = 
                                        ComplexTypeChildren.iterator();
                                    while (iComplexTypeChildren.hasNext()) {
                                        //parcourir les balises template
                                        Element currentSequence = 
                                            (Element)iComplexTypeChildren.next();
                                        System.out.println("fin" + 
                                                           currentSequence);

                                        List SequenceChildren = 
                                            currentSequence.getChildren();
                                        Iterator iSequenceChildren = 
                                            SequenceChildren.iterator();
                                        while (iSequenceChildren.hasNext()) {
                                            //parcourir les balises template
                                            Element currentElement = 
                                                (Element)iSequenceChildren.next();
                                            System.out.println("fin " + 
                                                               currentElement);
                                            String Complextype = 
                                                currentElement.getAttributeValue("type");
                                            String[] type;
                                            type = Complextype.split(":");
                                            parametersType.add(type[1]);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return parametersType;
    }
    
    /**
     * used to get the name of the web service output variable described in this wsdl
     *  
     **/
    public String  getOutpuName() {
       List children = racine.getChildren();
       
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            System.out.println(current);
            if (current.getName().equals("portType")){
                List portTypeChildren = current.getChildren(); 
                Iterator iportTypeChildren = portTypeChildren.iterator();
                while (iportTypeChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentOperation = (Element)iportTypeChildren.next();
                    if (currentOperation.getName().equals("operation")){
                        List inputChildren = currentOperation.getChildren();
                        Iterator iinputChildren = inputChildren.iterator();
                        while (iinputChildren.hasNext()) {
                            //parcourir les balises template
                            Element currentInput = (Element)iinputChildren.next();
                            if (currentInput.getName().equals("output")){
                                outputName = currentInput.getAttributeValue("name");
                            }
                        }
                    }
                }
            }
        }
        return outputName;
      
    }
}
