// This source file is generated by WSCCT group work 
// It is a utility is to invoking these following operations: 
// 1- connection to to xml file of the specification 
package tester;

import tester.State;

import java.io.File;

import java.net.MalformedURLException;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.jdom.input.SAXBuilder;
import org.jdom.Element;
import org.jdom.Document;


public class TreatmentSpec {
    public Document document;
    public Element racine;
    public String specPath;
    public List<String> partnersList = new ArrayList<String>();
    public List<String> descriptionList = new ArrayList<String>();
    public List<State> Listlocations = new ArrayList<State>();
    public List BPELpathsFiles;
    // la liste des locations qui sont suivies par  2 transitions
    public List<State> locationAvec2Transitions = new ArrayList<State>();
    public List<String> PathsList = new ArrayList<String>();
    public String BPELwsdlPath;
    public String BPELxsdPath;
    public Transition searchResult;

    public TreatmentSpec(String specPath) {
        this.specPath = specPath;
        specConnection();
    }

    /**
     * used to access the xml file of the specification
     * generated by UPPAAL 
     */
    public


    void specConnection() {
        //On cre une instance de SAXBuilder
        SAXBuilder sxb = new SAXBuilder();
        try {
            //On cre un nouveau document JDOM avec en argument le fichier XML
            //Le parsing est termin ;)
            // le fichier de spcification est celui donne pass dans le champ texte spcification de l'interface graphique fr
            document = sxb.build(new File(specPath));

        } catch (Exception e) {
            System.out.println(e);
        }

        //On initialise un nouvel lment racine avec l'lment racine du document.
        racine = document.getRootElement();
    }

    /**
     * used to get the clock name of the specification 
     */
    public

    String getClockName() {
        Element declaration = racine.getChild("declaration");
        Element clock = declaration.getChild("clock");
        return clock.getText();
    }

    /**
     * used to get the output variable name of the specification 
     */
    public


    String getVariableName() {
        Element declaration = racine.getChild("declaration");
        Element var = declaration.getChild("var");
        return var.getText();
    }


    /**
     *
     * used to verify that the xml file of the specification
     * contains the paths of xsd files and wsdl files of the BPEL (SUT)
     * and that contains also le WSDL Files of all partner Web server
     * PS : these informations was added to the specification after that was 
     * verified using the UPPAAL tool
     * 
     */
    public

    boolean verifySpec() {

        return true;
    }

    /**
     * used to get the list of partner services in the specification 
     */
    public

    List getPartnersList() {
        Element system = racine.getChild("system");
        String[] systemList;
        String[] processList;
        partnersList.clear();
        systemList = system.getText().split(";");
        int l = systemList.length;
        for (int i = 0; i < l - 1; i++) {
            processList = systemList[i].split("= ");
            if ((processList[1].contains("Template()") == false) && 
                (processList[1].contains("Customer()") != true)) {
                partnersList.add(processList[1]);
            }
        }
        return partnersList;
    }

    /**
     * used to get the number of partner services in the specification 
     */
    public

    int getPartnersNumber() {
        partnersList.clear();
        return getPartnersList().size();
    }

    /**
     * used to get the wsdl path of the BPEL composition
     */
    public

    String getBPELwsdlPath() {
        Element declaration = racine.getChild("declaration");
        BPELpathsFiles = declaration.getChildren("BPEL");
        //On cre un Iterator sur notre liste
        Iterator i = BPELpathsFiles.iterator();
        while (i.hasNext()) {
            //parcourir les balises template
            Element courant = (Element)i.next();
            String a = courant.getAttributeValue("file");
            if (courant.getAttributeValue("file").equals("wsdl")) {
                BPELwsdlPath = courant.getChild("path").getText();
            }
        }
        try {
            int len = BPELwsdlPath.length(); // Causes a NullPointerException
        } catch (Exception e) {
            // Print out the exception that occurred
            System.err.println("Specification does not contain the wsdl file of the BPEL");
            System.exit(0);
        }
        return BPELwsdlPath;
    }

    /**
     * used to get the xsd path of the BPEL composition
     */
    public

    String getBPELxsdPath() {
        Element declaration = racine.getChild("declaration");
        BPELpathsFiles = declaration.getChildren("BPEL");
        //On cre un Iterator sur notre liste
        Iterator i = BPELpathsFiles.iterator();
        while (i.hasNext()) {
            //parcourir les balises template
            Element courant = (Element)i.next();
            String a = courant.getAttributeValue("file");
            if (courant.getAttributeValue("file").equals("xsd")) {
                BPELxsdPath = courant.getChild("path").getText();
            }
        }
        try {
            int len = BPELxsdPath.length(); // Causes a NullPointerException
        } catch (Exception e) {
            // Print out the exception that occurred
            System.err.println("Specification does not contain the xsd file of the BPEL");
            System.exit(0);
        }
        return BPELxsdPath;
    }

    /**
     * used to get the list of the description of each partner service in the composition
     * every element in the list have the form : "NameService();wsdlPathFile;endPoint" 
     */
    public List getPartnersDescription() {
        Element declaration = racine.getChild("declaration");
        List services = declaration.getChildren("service");

        //On cre un Iterator sur notre liste
        Iterator i = services.iterator();
        //the description for each web service
        String description;
        while (i.hasNext()) {
            //initialize description
            description = "";
            //parcourir les balises template
            Element courant = (Element)i.next();
            String name = courant.getAttributeValue("name");
            description += name;
            String path = courant.getChild("path").getText();
            description += ";" + path;
            TreatmentWsdlOraclePartnerService taw = 
                new TreatmentWsdlOraclePartnerService(path);
            String endPoint = taw.getEndPoint();
            description += ";" + endPoint;
            System.out.println("description " + name + ": " + description);
            descriptionList.add(description);
        }
        return descriptionList;
    }


    /**
     * used to get the Sate list of the specification 
     */
    public List getStates() {
        Listlocations.clear();
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {
            //parcourir les balises template
            Element courant = (Element)i.next();
            //la template sur laquelle on travaille est la principale template  
            // qui a comme nom "Temlate"
            if (courant.getChild("name").getText().equals("Template")) {
                //listLocation contient les balises (type ELEMENT) de nom location dans la specification
                List listLocations = courant.getChildren("location");
                System.out.println(listLocations.size());
                Iterator j = listLocations.iterator();
                while (j.hasNext()) {
                    Element courantLocation = (Element)j.next();
                    //compter le nombre de balise qui dfinissent les locations
                    System.out.println(courantLocation.getAttributeValue("id"));
                    Listlocations.add(new State(courantLocation.getAttributeValue("id")));
                }
            }
        }
        return Listlocations;
    }

    /**
     * used to get the initial state of the specification 
     */
    public State getInitialState() {
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {
            //parcourir les balises template
            Element courant = (Element)i.next();
            //la template sur laquelle on travaille est la principale template  
            // qui a comme nom "Temlate"
            if (courant.getChild("name").getText().equals("Template")) {
                Element initialLocation = courant.getChild("init");
                return (new State(initialLocation.getAttributeValue("ref")));
            }
        }
        return null;
    }


    /**
     * used to get the list of transitions that follow one state 
     * @param s
     * @return list of transitions that folloawed a state s
     */
    public List getNextTransition(State s) {
        List<Transition> nextTransitions = new ArrayList<Transition>();
        nextTransitions.clear();
        //On cre une List contenant tous les noeuds "template" de l'Element racine
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {
            //parcourir les balises template
            Element courant = (Element)i.next();
            if (courant.getChild("name").getText().equals("Template")) {
                List listTransitions = courant.getChildren("transition");
                Iterator j = listTransitions.iterator();
                while (j.hasNext()) {
                    Element courantTransition = (Element)j.next();
                    //determinaison des transition qui ont comme source id
                    if (courantTransition.getChild("source").getAttributeValue("ref").equals(s.id)) {
                        State source = 
                            new State(courantTransition.getChild("source").getAttributeValue("ref"));
                        State target = 
                            new State(courantTransition.getChild("target").getAttributeValue("ref"));
                        nextTransitions.add(new Transition(source, target));
                    }
                }
            }
        }
        return nextTransitions;
    }

    /**
     * used to get the list of states followed by 2 transitions 
     * @param
     * @return list of states folloawed 2 transitions 
     */
    public List getTransitionsFollowedBy2Transitions() {
        locationAvec2Transitions.clear();
        String typeOfFolloawedTransition ;
        List statesList = getStates();
        Iterator istatesList = statesList.iterator();
        while (istatesList.hasNext()) {
                                            State statesListCourantState = (State)istatesList.next();
            //modification done 06-03-2012
            //transitions which are taken into account when calculating the path are those of type timed, input, guardInput, assignment only

            try {
                List acList = getNextTransition(statesListCourantState);
                if (acList.size() > 1) {
                    typeOfFolloawedTransition ="";
                    System.out.println("acList.size() =" + acList.size() + 
                                       " de " + statesListCourantState.id);


                    Iterator iAcList = acList.iterator();
                    while (iAcList.hasNext()) {
                        
                        Transition acListCourantTransition = (Transition)iAcList.next();
                        System.out.println(acListCourantTransition.source.id +   "->" +   acListCourantTransition.target.id);
                        String type =  this.getTypeTransition(acListCourantTransition);
                        System.out.println("type of current transition = " +   type);
                        if (type.equals("Input") || 
                            (type.equals("GuardInput")) || 
                            (type.equals("Timed")) ) {
                            typeOfFolloawedTransition = typeOfFolloawedTransition+type ;
                            }
                            if (typeOfFolloawedTransition.equals("InputTimed")||typeOfFolloawedTransition.equals("GuardInputTimed")||typeOfFolloawedTransition.equals("TimedGuardInput"))
                            {System.out.println("statesListCourantState.id " + 
                                               statesListCourantState.id);
                            //locationAvec2Transitions contient les location qui contiennt 2 transition (une de type timed et l'autre de type GuardInput)
                            locationAvec2Transitions.add(statesListCourantState);
                            }
                    }
                }
            } catch (Exception e) {
                System.out.println("nullpointerException");
            }
        }
        return locationAvec2Transitions;
    }

    /**
     * used to get the list of states followed by 2 transitions 
     * @param 
     * @return Pathlist =list of combinations
     * combination = for each state with two transitions choose the transition to cross
     * 
     */
    public List getPathsList() {
        List StatesWith2Transitions = getTransitionsFollowedBy2Transitions();
        String combination;
        System.out.println(Math.pow(2, StatesWith2Transitions.size()));
        for (int i = 0; i < Math.pow(2, locationAvec2Transitions.size()); 
             i++) {
            combination = Integer.toBinaryString(i);
            // chaque bit de s reprsente une location de laquelle sont issues plusieurs ramifications
            // si on a 3 locations avec plusieurs transitions dans la spcifications toutes les possibilits de s seront reprsentes
            // sur 3 bits
            while (combination.length() < locationAvec2Transitions.size()) {
                combination = '0' + combination;
            }
            // listeCheminsPossibles contient toutes les combinaisons possibles des locations qui ont plusieurs transitions
            PathsList.add(combination);
        }
        return PathsList;
    }

    /**
     * 
     * @param transition t
     * @return the type of one transition
     */
    public String getTypeTransition(Transition t) {
        String type = "";
        System.out.println(this.getVariableName());
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {

            //parcourir les balises template
            Element courant = (Element)i.next();
            List listTransitions = courant.getChildren("transition");
            Iterator iTransition = listTransitions.iterator();

            while (iTransition.hasNext()) {
                Element courantTransition = (Element)iTransition.next();

                //determinaison des transition qui ont comme source id
                if (courantTransition.getChild("source").getAttributeValue("ref").equals(t.source.id) && 
                    courantTransition.getChild("target").getAttributeValue("ref").equals(t.target.id)) {

                    List listLabels = courantTransition.getChildren("label");
                    Iterator iLabel = listLabels.iterator();
                    while (iLabel.hasNext()) {
                        Element courantLabel = (Element)iLabel.next();
                        int l = courantLabel.getText().length() - 1;
                        if (courantLabel.getText().charAt(l) == '?') {

                            type = type + "Input";

                        }
                        if (courantLabel.getText().charAt(l) == '!') {

                            type = type + "Output";
                        }
                        if (courantLabel.getAttributeValue("kind").equals("guard") && 
                            courantLabel.getText().contains(this.getVariableName())) {
                            type = type + "GuardVar";
                        }

                        if (courantLabel.getAttributeValue("kind").equals("guard") && 
                            courantLabel.getText().contains("=") && 
                            courantLabel.getText().contains(this.getClockName())) {
                            type = type + "Timed";
                        }
                        if (courantLabel.getAttributeValue("kind").equals("guard") && 
                            !(courantLabel.getText().contains("="))) {
                            type = type + "Guard";
                        }
                        if (courantLabel.getAttributeValue("kind").equals("assignment")) {
                            if (courantLabel.getText().contains("c"))
                                type = type + "AssignementClock";
                            else
                                type = type + "Assignement";
                        }
                    }

                }

            }
        }
        if (type.equals("")) {
            type = "free";
        }
        System.out.println("type = " + type);
        return type;
    }


    // la fontion generateDataOfInputTransition(t) permet de gnrer une information sur
    //ce que fait la transition, d'enregistrer dans i_msg l'activit  que fait la transition
    //cel nous permet de faciliter la lecture de test result et comprendre le chemin pris 
    //dans le test result


    public String generateActionOfInputTransition(State source, State target) {
        String i_msg = null;
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {
            //parcourir les balises template
            Element courant = (Element)i.next();
            List listTransitions = courant.getChildren("transition");
            Iterator iTransition = listTransitions.iterator();

            while (iTransition.hasNext()) {
                Element courantTransition = (Element)iTransition.next();

                //determinaison des transition qui ont comme source id
                if (courantTransition.getChild("source").getAttributeValue("ref").equals(source.id) && 
                    courantTransition.getChild("target").getAttributeValue("ref").equals(target.id)) {

                    List listLabels = courantTransition.getChildren("label");
                    Iterator iLabel = listLabels.iterator();
                    while (iLabel.hasNext()) {
                        Element courantLabel = (Element)iLabel.next();
                        int l = courantLabel.getText().length() - 1;
                        //on a spcifi la label qui prcise la fonction que fait 
                        //input transition (celle qui se termine par '?' parce que
                        //dans certain, on trouve des input transition qui contiennet aussi
                        //les labels de type 'guard' par exemple une pour une transition qui contient
                        // ces deux labels '?res_msg' et 'c<60', dans ce cas i_msg= '?res_msg'
                        if (courantLabel.getText().charAt(l) == '?') {
                            i_msg = courantLabel.getText();
                        }
                    }
                }
            }
        }
        return i_msg;
    }

    /**
     * used to get the action described in the specof aa timed transition
     */
    public String generateActionOfTimedTransition(State source, State target) {
        String i_msg = null;
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {

            //parcourir les balises template
            Element courant = (Element)i.next();
            List listTransitions = courant.getChildren("transition");
            Iterator iTransition = listTransitions.iterator();

            while (iTransition.hasNext()) {
                Element courantTransition = (Element)iTransition.next();
                //determinaison des transition qui ont comme source id
                if (courantTransition.getChild("source").getAttributeValue("ref").equals(source.id) && 
                    courantTransition.getChild("target").getAttributeValue("ref").equals(target.id)) {

                    List listLabels = courantTransition.getChildren("label");
                    Iterator iLabel = listLabels.iterator();
                    while (iLabel.hasNext()) {
                        Element courantLabel = (Element)iLabel.next();
                        //on doit extraire la dlai de la trasition timed exemple pour "c=60" la dlai = 60

                        i_msg = courantLabel.getText();

                    }
                }
            }
        }
        return i_msg;
    }

    /**
     * used to generate action of an Assignment Transition
     */

    String generateActionOfAssignmentTransition(State source, State target) {
        System.out.println("Action Assignment");
        String i_msg = null;
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {

            //parcourir les balises template
            Element courant = (Element)i.next();
            List listTransitions = courant.getChildren("transition");
            Iterator iTransition = listTransitions.iterator();

            while (iTransition.hasNext()) {
                Element courantTransition = (Element)iTransition.next();

                //determinaison des transition qui ont comme source id
                if (courantTransition.getChild("source").getAttributeValue("ref").equals(source.id) && 
                    courantTransition.getChild("target").getAttributeValue("ref").equals(target.id)) {

                    List listLabels = courantTransition.getChildren("label");
                    Iterator iLabel = listLabels.iterator();
                    while (iLabel.hasNext()) {
                        Element courantLabel = (Element)iLabel.next();
                        i_msg = courantLabel.getText();

                    }
                }
            }
        }
        return i_msg;
    }
    
    String generateActionOfGuardVarTransition(State source, State target) {
        System.out.println("Action guardVar");
        String i_msg = null;
        List listTemplates = racine.getChildren("template");
        //On cre un Iterator sur notre liste
        Iterator i = listTemplates.iterator();
        while (i.hasNext()) {

            //parcourir les balises template
            Element courant = (Element)i.next();
            List listTransitions = courant.getChildren("transition");
            Iterator iTransition = listTransitions.iterator();

            while (iTransition.hasNext()) {
                Element courantTransition = (Element)iTransition.next();

                //determinaison des transition qui ont comme source id
                if (courantTransition.getChild("source").getAttributeValue("ref").equals(source.id) && 
                    courantTransition.getChild("target").getAttributeValue("ref").equals(target.id)) {

                    List listLabels = courantTransition.getChildren("label");
                    Iterator iLabel = listLabels.iterator();
                    while (iLabel.hasNext()) {
                        Element courantLabel = (Element)iLabel.next();
                        i_msg = courantLabel.getText();

                    }
                }
            }
        }
        return i_msg;
    }

    /**
     * used to get the name of the partner service from its description in the wsdl
     * this descrition contains three items: name;path;endPoint
     * the name is the first item
     * @param PartnerDescription
     * @return the name of partner service 
     * 
     */
    public String getPartnerServiceName(String PartnerDescription) {
        String[] DescriptionList;
        DescriptionList = PartnerDescription.split(";");
        return DescriptionList[0];
    }

    /**
     * 
     * @param PartnerDescription
     * @return the path of the wdsl file of the partner service wich the description is PartnerDescription
     */
    public String getPartnerServicePath(String PartnerDescription) {
        String[] DescriptionList;
        DescriptionList = PartnerDescription.split(";");
        return DescriptionList[1];
    }

    /**
     * used to check if that exists a transtion from labeled o_msg from the current state
     * @param o_msg
     * @param s
     * @return transition wich the sourse is s and labeled with o_msg
     */
    public Transition search(String o_msg, State s) {
        System.out.println("on commence search");
        System.out.println("(search (" + o_msg + "," + s.id + ")");

        List<Transition> nextTransitions = getNextTransition(s);
        Iterator inextTransitions = nextTransitions.iterator();
        //Remplir itList qui contient les transitions input et ouput qui suivent a une transition
        while (inextTransitions.hasNext()) {
            Transition nextTransition = (Transition)inextTransitions.next();
            List listTemplates = racine.getChildren("template");
            //On cre un Iterator sur notre liste
            Iterator i = listTemplates.iterator();
            while (i.hasNext()) {

                //parcourir les balises template
                Element courant = (Element)i.next();
                List listTransitions = courant.getChildren("transition");
                Iterator iTransition = listTransitions.iterator();

                while (iTransition.hasNext()) {
                    Element courantTransition = (Element)iTransition.next();

                    //determinaison des transitions de la spcification qui correspondent  celles trouves dans nextTransitions
                    if (courantTransition.getChild("source").getAttributeValue("ref").equals(nextTransition.source.id) && 
                        courantTransition.getChild("target").getAttributeValue("ref").equals(nextTransition.target.id)) {
                        // lire les labels de ces transitions
                        List listLabels = 
                            courantTransition.getChildren("label");
                        System.out.println(listLabels.size());
                        Iterator iLabel = listLabels.iterator();
                        while (iLabel.hasNext()) {
                            Element courantLabel = (Element)iLabel.next();
                            //si un label correspond  l'opration effectue 
                            if (courantLabel.getAttributeValue("kind").equals("assignment")) {
                                System.out.println(courantLabel.getText());

                                // dterminer la transition qui a un label gal  o_msg
                                if (courantLabel.getText().equals(o_msg)) {
                                    //TestDeConformite.operationSpecification=courantLabel.getText();
                                    System.out.println("checkSearch1");
                                    searchResult = nextTransition;
                                    return searchResult;
                                } else
                                    searchResult = null;

                            }
                        }
                    }
                }
            }
        }
        return searchResult;
    }

    public static void main(String[] args) {
        TreatmentSpec ts = 
            new TreatmentSpec("C:\\jdevstudio10133\\jdev\\mywork\\BloodBanking\\Project6\\BloodBanking.xml");
        ts.getTypeTransition(new Transition(new State("id5"), 
                                            new State("id3")));
                                            
                                            
        System.out.println(ts.generateActionOfGuardVarTransition(new State("id5"),new State("id3")));

    }
}
