package tester;

import java.io.File;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

public class TreatmentWsdlOraclePartnerService {
    public Document document;
    public Element racine;
    public String wsdlPath;
    public String endPoint;
    public String nameInput;
    public String partName;
    public String outputName;
    public List<String> parametersType = new ArrayList<String>();
    public String type = null;
   
   
   
    public TreatmentWsdlOraclePartnerService(String wsdlPath) {
        this.wsdlPath=wsdlPath;
        wsdlConnection();
    }
    
    /**
     * used to access the wsdl file of the partner service 
     * generated by Oracle
     */
    public void wsdlConnection(){
        //On cre une instance de SAXBuilder
        SAXBuilder sxb = new SAXBuilder();
              try {
            //On cre un nouveau document JDOM avec en argument le fichier XML
            //Le parsing est termin ;)
            // le fichier de spcification est celui donne pass dans le champ texte spcification de l'interface graphique fr
            document = sxb.build(new File(wsdlPath));
            } catch (Exception e) {
            System.out.println(e);
        }

        //On initialise un nouvel lment racine avec l'lment racine du document.
        racine = document.getRootElement();
    }
    
    
    /**
     * used to get the endpoint of the web service described by this wsdl
     * 
     **/
    public String  getEndPoint() {
       List children = racine.getChildren();
       
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            
            if (current.getName().equals("service")){
                List serviceChildren = current.getChildren(); 
                Iterator iServiceChildren = serviceChildren.iterator();
                while (iServiceChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentPort = (Element)iServiceChildren.next();
                    if (currentPort.getName().equals("port")){
                        List portChildren = currentPort.getChildren();
                        Iterator iPortChildren = portChildren.iterator();
                        while (iPortChildren.hasNext()) {
                            //parcourir les balises template
                            Element currentAddress = (Element)iPortChildren.next();
                            if (currentAddress.getName().equals("address")){
                                endPoint = currentAddress.getAttributeValue("location");
                            }
                        }
                    }
                }
            }
        }
        
        return endPoint;
      
    }
    /**
     * used to get the name of the web service input variable described in this wsdl
     * This item includes all input parameters  
     **/
    public String  getInputName() {
       List children = racine.getChildren();
       
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            if (current.getName().equals("portType")){
                List portTypeChildren = current.getChildren(); 
                Iterator iportTypeChildren = portTypeChildren.iterator();
                while (iportTypeChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentOperation = (Element)iportTypeChildren.next();
                    if (currentOperation.getName().equals("operation")){
                        List inputChildren = currentOperation.getChildren();
                        Iterator iinputChildren = inputChildren.iterator();
                        while (iinputChildren.hasNext()) {
                            //parcourir les balises template
                            Element currentInput = (Element)iinputChildren.next();
                            if (currentInput.getName().equals("input")){
                                nameInput = currentInput.getAttributeValue("name");
                            }
                        }
                    }
                }
            }
        }
        return nameInput;
      
    }
    
    /**
     * used to get the type of the (input/ output ) of the  web service 
     * 
     **/
    public String getType(String name) {
        List children = racine.getChildren();
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            if (current.getName().equals("message") && 
                (current.getAttributeValue("name").equals(name))) {
                List messageChildren = current.getChildren();
                Iterator imessageChildren = messageChildren.iterator();
                while (imessageChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentPart = (Element)imessageChildren.next();
                  partName = currentPart.getAttributeValue("type"); 
                  String partNameDescription[];
                  partNameDescription = partName.split(":");
                  type = partNameDescription[1];
                }
            }
        }
        return type;
    }

   
    
    /**
     * used to get the name of the web service output variable described in this wsdl
     *  
     **/
    public String  getOutpuName() {
       List children = racine.getChildren();
       
        Iterator ichildren = children.iterator();
        while (ichildren.hasNext()) {
            //parcourir les balises template
            Element current = (Element)ichildren.next();
            if (current.getName().equals("portType")){
                List portTypeChildren = current.getChildren(); 
                Iterator iportTypeChildren = portTypeChildren.iterator();
                while (iportTypeChildren.hasNext()) {
                    //parcourir les balises template
                    Element currentOperation = (Element)iportTypeChildren.next();
                    if (currentOperation.getName().equals("operation")){
                        List inputChildren = currentOperation.getChildren();
                        Iterator iinputChildren = inputChildren.iterator();
                        while (iinputChildren.hasNext()) {
                            //parcourir les balises template
                            Element currentInput = (Element)iinputChildren.next();
                            if (currentInput.getName().equals("output")){
                                outputName = currentInput.getAttributeValue("name");
                            }
                        }
                    }
                }
            }
        }
        return outputName;
    }
    public static void main (String args []){
        TreatmentWsdlOraclePartnerService twPS = new TreatmentWsdlOraclePartnerService("C:\\jdevstudio10133\\jdev\\mywork\\Application4\\BPELProcess2\\bpel\\IServiceA.wsdl");
        System.out.println(twPS.getType(twPS.getInputName()));
        System.out.println(twPS.getOutpuName());
        System.out.println(twPS.getType(twPS.getOutpuName()));

    }
}
